# mypy-boto3-sts

[![PyPI - mypy-boto3-sts](https://img.shields.io/pypi/v/mypy-boto3-sts.svg?color=blue)](https://pypi.org/project/mypy-boto3-sts)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-sts.svg?color=blue)](https://pypi.org/project/mypy-boto3-sts)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.STS 1.16.28](https://boto3.amazonaws.com/v1/documentation/api/1.16.28/reference/services/sts.html#STS) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 4.0.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-sts](#mypy-boto3-sts)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `STS` service.

```bash
python -m pip install boto3-stubs[sts]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[sts]` in your environment: `python -m pip install 'boto3-stubs[sts]'`

Both type checking and auto-complete should work for `STS` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[sts]` in your environment: `python -m pip install 'boto3-stubs[sts]'`

Both type checking and auto-complete should work for `STS` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[sts]` in your environment: `python -m pip install 'boto3-stubs[sts]'`
- Run `mypy` as usual

Type checking should work for `STS` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[sts]` in your environment: `python -m pip install 'boto3-stubs[sts]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `STS` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`STSClient` provides annotations for `boto3.client("sts")`.

```python
import boto3

from mypy_boto3_sts import STSClient

client: STSClient = boto3.client("sts")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: STSClient = session.client("sts")
```








### Typed dictionations

`mypy_boto3_sts.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_sts.type_defs import (
    AssumedRoleUserTypeDef,
    AssumeRoleResponseTypeDef,
    AssumeRoleWithSAMLResponseTypeDef,
    AssumeRoleWithWebIdentityResponseTypeDef,
    CredentialsTypeDef,
    DecodeAuthorizationMessageResponseTypeDef,
    FederatedUserTypeDef,
    GetAccessKeyInfoResponseTypeDef,
    GetCallerIdentityResponseTypeDef,
    GetFederationTokenResponseTypeDef,
    GetSessionTokenResponseTypeDef,
    PolicyDescriptorTypeTypeDef,
    TagTypeDef,
)

def get_structure() -> AssumedRoleUserTypeDef:
    return {
      ...
    }
```
